//////////////////////////////////////////////////////////////////////
// mobile.cpp: implementation for the Mobile class (Hierarchical Transformation).
// -Kyoung Shin Park
//////////////////////////////////////////////////////////////////////
#include "babyMobile.h"

namespace moglclass
{
const float BabyMobile::MobileDistanceFromHead = 4.0f;

BabyMobile::BabyMobile()
{
	angle = 0.0f; // 0~360

	direction = 1.0f; // +/-1
	position = glm::vec3(-2.0f, 0.0f, 0.0f);
	active = false;

	init();
}

void BabyMobile::init()
{
	// Ʋ
	frame1 = Cylinder(glm::vec3(0, 0, 0), 1.0f, 1.0f, 1.0f, 5);
	frame2 = Cylinder(glm::vec3(0, -1.5, 0), 8.0f, 1.0f, 3.0f, 5);
	frame3 = Cylinder(glm::vec3(0, -2, 0), 0.05f, 0.05f, 4.0f, 32);
	frame4 = Cylinder(glm::vec3(0, -3, 0), 0.05f, 0.05f, 6.0f, 32);
	frame5 = Cylinder(glm::vec3(0, -2.5, 0), 0.05f, 0.05f, 5.0f, 32);
	frame6 = Cylinder(glm::vec3(0, -3, 0), 0.05f, 0.05f, 6.0f, 32);
	frame7 = Cylinder(glm::vec3(0, -2, 0), 0.05f, 0.05f, 4.0f, 32);
	frame8 = Cylinder(glm::vec3(0, -5, 0), 0.15f, 0.15f, 10.0f, 32);
	frame1.setColor(glm::vec3(0.8, 0.7, 1)); //
	frame2.setColor(glm::vec3(0.8, 0.7, 1)); 
	frame3.setColor(glm::vec3(0.8, 0.7, 1));
	frame4.setColor(glm::vec3(0.8, 0.7, 1));
	frame5.setColor(glm::vec3(0.8, 0.7, 1)); 
	frame6.setColor(glm::vec3(0.8, 0.7, 1));
	frame7.setColor(glm::vec3(0.8, 0.7, 1));
	frame8.setColor(glm::vec3(0.8, 0.7, 1));

	//
	beehead = Sphere(glm::vec3(0, 0, 0), 1.5f, 16, 16);
	beehead.setColor(glm::vec3(0.3, 0.3, 0.3));
	beebody = Sphere(glm::vec3(0, 0, 0), 2.3f, 16, 16);
	beebody.setColor(glm::vec3(1, 0.36, 0));  // 
	beewing1 = Circle(glm::vec3(0, 0, 0), 1.8f, 16);
	beewing1.setColor(glm::vec3(1, 0.9, 0));  // 
	beewing2 = Circle(glm::vec3(0, 0, 0), 1.8f, 16);
	beewing2.setColor(glm::vec3(1, 0.9, 0));
	beewing3 = Circle(glm::vec3(0, 0, 0), 1.3f, 16);
	beewing3.setColor(glm::vec3(1, 0.9, 0));
	beewing4 = Circle(glm::vec3(0, 0, 0), 1.3f, 16);
	beewing4.setColor(glm::vec3(1, 0.9, 0));

	//
	penguinbody = Sphere(glm::vec3(0, 0, 0), 2.5f, 16, 16);
	penguinbody.setColor(glm::vec3(0, 0.3, 1));  // Ķ
	penguineye = Sphere(glm::vec3(0, 0, 0), 0.5f, 16, 16); 
	penguineye.setColor(glm::vec3(0, 0, 0));  // 
	penguineye2 = Sphere(glm::vec3(0, 0, 0), 0.5f, 16, 16); 
	penguineye2.setColor(glm::vec3(0, 0, 0));  // 
	penguinbody2 = Sphere(glm::vec3(0, 0, 0), 1.8f, 16, 16);
	penguinbody2.setColor(glm::vec3(0.95, 0.95, 0.95));  // 

	//
	ladybug = Sphere(glm::vec3(0, 0, 0), 2.5f, 16, 16); 
	ladybug.setColor(glm::vec3(1, 0, 0));  // 
	lbleg1 = Parallelepiped(glm::vec3(1.5f, 1.0f, 0.0f), glm::vec3(1.0f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.3f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg1.setColor(glm::vec3(0, 0, 0));  // 
	lbleg2 = Parallelepiped(glm::vec3(2.5f, 1.0f, 0.0f), glm::vec3(0.3f, 0.0f, 0.0f), glm::vec3(0.0f, -0.5f, 0.0f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg2.setColor(glm::vec3(0, 0, 0));  // 
	lbleg3 = Parallelepiped(glm::vec3(2.0f, 0.0f, 0.0f), glm::vec3(0.8f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.3f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg3.setColor(glm::vec3(0, 0, 0));  // 
	lbleg4 = Parallelepiped(glm::vec3(2.8f, 0.0f, 0.0f), glm::vec3(0.3f, 0.0f, 0.0f), glm::vec3(0.0f, -0.5f, 0.0f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg4.setColor(glm::vec3(0, 0, 0));  // 
	lbleg5 = Parallelepiped(glm::vec3(1.5f, -1.0f, 0.0f), glm::vec3(1.0f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.3f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg5.setColor(glm::vec3(0, 0, 0));  // 
	lbleg6 = Parallelepiped(glm::vec3(2.5f, -1.0f, 0.0f), glm::vec3(0.3f, 0.0f, 0.0f), glm::vec3(0.0f, -0.5f, 0.0f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg6.setColor(glm::vec3(0, 0, 0));  // 
	lbleg7 = Parallelepiped(glm::vec3(-3.0f, 1.0f, 0.0f), glm::vec3(1.0f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.3f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg7.setColor(glm::vec3(0, 0, 0));  // 
	lbleg8 = Parallelepiped(glm::vec3(-3.0f, 1.0f, 0.0f), glm::vec3(0.3f, 0.0f, 0.0f), glm::vec3(0.0f, -0.5f, 0.0f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg8.setColor(glm::vec3(0, 0, 0));  // 
	lbleg9 = Parallelepiped(glm::vec3(-3.3f, 0.0f, 0.0f), glm::vec3(0.8f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.3f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg9.setColor(glm::vec3(0, 0, 0));  // 
	lbleg10 = Parallelepiped(glm::vec3(-3.3f, 0.0f, 0.0f), glm::vec3(0.3f, 0.0f, 0.0f), glm::vec3(0.0f, -0.5f, 0.0f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg10.setColor(glm::vec3(0, 0, 0));  // 
	lbleg11 = Parallelepiped(glm::vec3(-3.0f, -1.0f, 0.0f), glm::vec3(1.0f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.3f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg11.setColor(glm::vec3(0, 0, 0));  // 
	lbleg12 = Parallelepiped(glm::vec3(-3.0f, -1.0f, 0.0f), glm::vec3(0.3f, 0.0f, 0.0f), glm::vec3(0.0f, -0.5f, 0.0f), glm::vec3(0.0f, 0.3f, 0.0f));
	lbleg12.setColor(glm::vec3(0, 0, 0));  // 
	lbspot1 = Sphere(glm::vec3(0, 0, 0), 0.4f, 16, 16);
	lbspot1.setColor(glm::vec3(0, 0, 0));  // 
	lbspot2 = Sphere(glm::vec3(0, 0, 0), 0.4f, 16, 16);
	lbspot2.setColor(glm::vec3(0, 0, 0));  // 
	lbspot3 = Sphere(glm::vec3(0, 0, 0), 0.4f, 16, 16);
	lbspot3.setColor(glm::vec3(0, 0, 0));  // 
	lbspot4 = Sphere(glm::vec3(0, 0, 0), 0.4f, 16, 16);
	lbspot4.setColor(glm::vec3(0, 0, 0));  // 

	//
	pighead = Sphere(glm::vec3(0, 0, 0), 1.8f, 16, 16);
	pighead.setColor(glm::vec3(1, 0.35, 1));  // ȫ
	pigbody = Sphere(glm::vec3(0, 0, 0), 2.2f, 16, 16);
	pigbody.setColor(glm::vec3(1, 0, 0.86)); // ȫ
	pigear1 = Triangle(glm::vec3(-2.0f, 0.5f, 0), glm::vec3(-0.5, 1, 0), glm::vec3(0.5, 1, 0), glm::vec3(0, -1, 0)); // InvertTriangle(glm::vec3(0, 0, 0), 1.0f);
	pigear1.setColor(glm::vec3(1, 0.85, 0.95));
	pigear2 = Triangle(glm::vec3(2.0f, 0.5f, 0), glm::vec3(-0.5, 1, 0), glm::vec3(0.5, 1, 0), glm::vec3(0, -1, 0)); // InvertTriangle(glm::vec3(0, 0, 0), 1.0f);
	pigear2.setColor(glm::vec3(1, 0.85, 0.95));
	pigeye1 = Sphere(glm::vec3(0, 0, 0), 0.3f, 16, 16); 
	pigeye1.setColor(glm::vec3(0, 0, 0));
	pigeye2 = Sphere(glm::vec3(0, 0, 0), 0.3f, 16, 16); 
	pigeye2.setColor(glm::vec3(0, 0, 0));
	pignose = Sphere(glm::vec3(0, 0, 0), 0.6f, 16, 16); 
	pignose.setColor(glm::vec3(0.95, 0.4, 0.65));
	pignose1 = Sphere(glm::vec3(0, 0, 0), 0.2f, 16, 16); 
	pignose1.setColor(glm::vec3(0, 0, 0));
	pignose2 = Sphere(glm::vec3(0, 0, 0), 0.2f, 16, 16);
	pignose2.setColor(glm::vec3(0, 0, 0));

	//
	frog = Sphere(glm::vec3(0, 0, 0), 2.5f, 16, 16); 
	frog.setColor(glm::vec3(0.67, 0.95, 0));  // λ
	frogeye1 = Sphere(glm::vec3(0, 0, 0), 1.0f, 16, 16);
	frogeye1.setColor(glm::vec3(0.95, 0.95, 0.95));  // 
	frogeye2 = Sphere(glm::vec3(0, 0, 0), 1.0f, 16, 16);
	frogeye2.setColor(glm::vec3(0.95, 0.95, 0.95));  // 
	frogeye11 = Sphere(glm::vec3(0, 0, 0), 0.5f, 16, 16);
	frogeye11.setColor(glm::vec3(0, 0, 0));
	frogeye21 = Sphere(glm::vec3(0, 0, 0), 0.5f, 16, 16);
	frogeye21.setColor(glm::vec3(0, 0, 0));

	//Ʈ
	tree1 = Cylinder(glm::vec3(0, -1, 0), 2.5f, 0.05f, 4.0f, 4); 
	tree1.setColor(glm::vec3(0, 1, 0));
	tree2 = Cylinder(glm::vec3(0, -2, 0), 4.0f, 0.5f, 4.0f, 4);
	tree2.setColor(glm::vec3(0, 1, 0));
}

void BabyMobile::draw(Program* p, glm::mat4 projection, glm::mat4 view, glm::mat4 model)
{
	p->useProgram();
	p->setUniform("gProjection", projection);
	p->setUniform("gView", view);

	glm::mat4 mobileMatrix = model * bodyTransform * wheelTransform[0];  //  
	p->setUniform("gModel", mobileMatrix);
	frame1.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[1];   // 
	p->setUniform("gModel", mobileMatrix);
	frame2.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[2]; //
	p->setUniform("gModel", mobileMatrix);
	frame3.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[3];  //ϱ
	p->setUniform("gModel", mobileMatrix);
	frame4.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[4];  //
	p->setUniform("gModel", mobileMatrix);
	frame5.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[5];  //
	p->setUniform("gModel", mobileMatrix);
	frame6.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[6];  //
	p->setUniform("gModel", mobileMatrix);
	frame7.draw();

	mobileMatrix = model * bodyTransform * wheelTransform[7];  // Ʈ
	p->setUniform("gModel", mobileMatrix);
	frame8.draw();
	
	//
	mobileMatrix = model * bodyTransform * beeTransform[0];  //beehead
	p->setUniform("gModel", mobileMatrix);
	beehead.draw();

	mobileMatrix = model * bodyTransform * beeTransform[2];  //beebody
	p->setUniform("gModel", mobileMatrix);
	beebody.draw();

	mobileMatrix = model * bodyTransform * beeTransform[3];  //beewing1
	p->setUniform("gModel", mobileMatrix);
	beewing1.draw();

	mobileMatrix = model * bodyTransform * beeTransform[4];  //beewing2
	p->setUniform("gModel", mobileMatrix);
	beewing2.draw();

	mobileMatrix = model * bodyTransform * beeTransform[5];  //beewing3
	p->setUniform("gModel", mobileMatrix);
	beewing3.draw();

	mobileMatrix = model * bodyTransform * beeTransform[6];  //beewing4
	p->setUniform("gModel", mobileMatrix);
	beewing4.draw();
	
	//
	mobileMatrix = model * bodyTransform * penguinTransform[0];  //penguinbody
	p->setUniform("gModel", mobileMatrix);
	penguinbody.draw();

	mobileMatrix = model * bodyTransform * penguinTransform[1];  //penguineye
	p->setUniform("gModel", mobileMatrix);
	penguineye.draw();

	mobileMatrix = model * bodyTransform * penguinTransform[2];  //penguineye2
	p->setUniform("gModel", mobileMatrix);
	penguineye2.draw();

	mobileMatrix = model * bodyTransform * penguinTransform[3];  //penguinbody
	p->setUniform("gModel", mobileMatrix);
	penguinbody2.draw();
	
	//
	mobileMatrix = model * bodyTransform * ladybugTransform[0] * ladybugTransform[7];  //body
	p->setUniform("gModel", mobileMatrix);
	ladybug.draw();

	mobileMatrix = model * bodyTransform * ladybugTransform[1] * ladybugTransform[7];  //right legs
	p->setUniform("gModel", mobileMatrix);
	lbleg1.draw();
	lbleg2.draw();
	lbleg3.draw();
	lbleg4.draw();
	lbleg5.draw();
	lbleg6.draw();

	mobileMatrix = model * bodyTransform * ladybugTransform[2] * ladybugTransform[7];  //left legs
	p->setUniform("gModel", mobileMatrix);
	lbleg7.draw();
	lbleg8.draw();
	lbleg9.draw();
	lbleg10.draw();
	lbleg11.draw();
	lbleg12.draw();

	mobileMatrix = model * bodyTransform * ladybugTransform[3] * ladybugTransform[7];  //spot1
	p->setUniform("gModel", mobileMatrix);
	lbspot1.draw();

	mobileMatrix = model * bodyTransform * ladybugTransform[4] * ladybugTransform[7];  //spot2
	p->setUniform("gModel", mobileMatrix);
	lbspot2.draw();

	mobileMatrix = model * bodyTransform * ladybugTransform[5] * ladybugTransform[7];  //spot3
	p->setUniform("gModel", mobileMatrix);
	lbspot3.draw();

	mobileMatrix = model * bodyTransform * ladybugTransform[6] * ladybugTransform[7];  //spot4
	p->setUniform("gModel", mobileMatrix);
	lbspot4.draw();
	
	//pig
	mobileMatrix = model * bodyTransform * pigTransform[0];  //head
	p->setUniform("gModel", mobileMatrix);
	pighead.draw();

	mobileMatrix = model * bodyTransform * pigTransform[1];  //body
	p->setUniform("gModel", mobileMatrix);
	pigbody.draw();

	mobileMatrix = model * bodyTransform * pigTransform[2];  //pigear
	p->setUniform("gModel", mobileMatrix);
	pigear1.draw();

	mobileMatrix = model * bodyTransform * pigTransform[3];  //pigear
	p->setUniform("gModel", mobileMatrix);
	pigear2.draw();

	mobileMatrix = model * bodyTransform * pigTransform[4];  //pigeye1
	p->setUniform("gModel", mobileMatrix);
	pigeye1.draw();

	mobileMatrix = model * bodyTransform * pigTransform[5];  //pigeye2
	p->setUniform("gModel", mobileMatrix);
	pigeye2.draw();

	mobileMatrix = model * bodyTransform * pigTransform[6];  //pignose
	p->setUniform("gModel", mobileMatrix);
	pignose.draw();

	mobileMatrix = model * bodyTransform * pigTransform[7];  
	p->setUniform("gModel", mobileMatrix);
	pignose1.draw();

	mobileMatrix = model * bodyTransform * pigTransform[8];  
	p->setUniform("gModel", mobileMatrix);
	pignose2.draw();

	//frog
	mobileMatrix = model * bodyTransform * frogTransform[0];  //frog
	p->setUniform("gModel", mobileMatrix);
	frog.draw();

	mobileMatrix = model * bodyTransform * frogTransform[1];  //
	p->setUniform("gModel", mobileMatrix);
	frogeye1.draw();

	mobileMatrix = model * bodyTransform * frogTransform[2];  
	p->setUniform("gModel", mobileMatrix);
	frogeye2.draw();

	mobileMatrix = model * bodyTransform * frogTransform[3];  //
	p->setUniform("gModel", mobileMatrix);
	frogeye11.draw();

	mobileMatrix = model * bodyTransform * frogTransform[4];  
	p->setUniform("gModel", mobileMatrix);
	frogeye21.draw();

	//Ʈ
	mobileMatrix = model * bodyTransform * treeTransform[0];  //Ʈ1
	p->setUniform("gModel", mobileMatrix);
	tree1.draw();

	mobileMatrix = model * bodyTransform * treeTransform[1];  //Ʈ2
	p->setUniform("gModel", mobileMatrix);
	tree2.draw();
}

bool BabyMobile::update(float deltaTime)
{
	if (active)
	{
		angle = angle - 180.0f * (float)(deltaTime) * 0.000001f;
	}

	//ġ
	bodyTransform = glm::rotate(glm::mat4(1.0f), angle, glm::vec3(0, 1, 0));
	wheelTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(0.0f, 8.0f, 0.0f)) * glm::rotate(glm::mat4(1.0f), angle, glm::vec3(0.0f, 1.0f, 0.0f)); //frame1
	wheelTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(0.0f, 6.0f, 0.0f)); //frame2
	wheelTransform[2] = glm::translate(glm::mat4(1.0f), glm::vec3(7.7f, 2.6f, 0.0f)); //frame3
	wheelTransform[3] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, 1.6f, 7.3f)); //frame4
	wheelTransform[4] = glm::translate(glm::mat4(1.0f), glm::vec3(-6.3f, 2.0f, 4.6f)); //frame5
	wheelTransform[5] = glm::translate(glm::mat4(1.0f), glm::vec3(-6.3f, 1.6f, -4.5f)); //frame6
	wheelTransform[6] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, 2.6f, -7.3f)); //frame7
	wheelTransform[7] = glm::translate(glm::mat4(1.0f), glm::vec3(0.0f, 2.6f, 0.0f)); //frame8

	beeTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(7.7f, 0.0f, 0.0f)); //beeeye1
	beeTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(-0.8f, 0.5f, 4.0f)); //beeeye2
	beeTransform[2] = glm::translate(glm::mat4(1.0f), glm::vec3(7.7f, -3.2f, 0.0f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //beebody
	beeTransform[3] = glm::translate(glm::mat4(1.0f), glm::vec3(9.7f, -2.0f, 0.0f)); //beewing1
	beeTransform[4] = glm::translate(glm::mat4(1.0f), glm::vec3(5.7f, -2.0f, 0.0f)); //beewing2
	beeTransform[5] = glm::translate(glm::mat4(1.0f), glm::vec3(9.7f, -4.0f, 0.0f)); //beewing3
	beeTransform[6] = glm::translate(glm::mat4(1.0f), glm::vec3(5.7f, -4.0f, 0.0f)); //beewing4

	penguinTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, -2.5f, 7.3f)) * glm::rotate(glm::mat4(1.0f), angle*5, glm::vec3(0.0f, 1.0f, 0.0f)); //penguinboody
	penguinTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(1.3f, -1.5f, 9.3f)) * glm::rotate(glm::mat4(1.0f), angle*5, glm::vec3(0.0f, 1.0f, 0.0f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //penguineye
	penguinTransform[2] = glm::translate(glm::mat4(1.0f), glm::vec3(3.3f, -1.5f, 9.3f)) * glm::rotate(glm::mat4(1.0f), angle*5, glm::vec3(0.0f, 1.0f, 0.0f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //penguineye2
	penguinTransform[3] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, -3.0f, 8.3f)) * glm::rotate(glm::mat4(1.0f), angle*5, glm::vec3(0.0f, 1.0f, 0.0f)); //penguineye2

	ladybugTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(-6.3f, -1.5f, 4.6f)) * glm::scale(glm::mat4(1.0f), glm::vec3(1.0f, 1.0f, 0.5f)); //ladybugbody
	ladybugTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(-6.3f, -1.5f, 4.6f)); //lbleg1
	ladybugTransform[2] = glm::translate(glm::mat4(1.0f), glm::vec3(-6.3f, -1.5f, 4.6f)); //lbleg1
	ladybugTransform[3] = glm::translate(glm::mat4(1.0f), glm::vec3(-7.3f, -1.0f, 5.5f)); //lbspot1
	ladybugTransform[4] = glm::translate(glm::mat4(1.0f), glm::vec3(-5.3f, -1.0f, 5.5f)); //lbspot2
	ladybugTransform[5] = glm::translate(glm::mat4(1.0f), glm::vec3(-7.3f, -2.5f, 5.4f)); //lbspot3
	ladybugTransform[6] = glm::translate(glm::mat4(1.0f), glm::vec3(-5.3f, -2.5f, 5.4f)); //lbspot4
	ladybugTransform[7] = glm::rotate(glm::mat4(1.0f), angle * 5, glm::vec3(0.0f, 0.0f, 1.0f));

	frogTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(-6.3f, -2.4f, -4.5f)) * glm::rotate(glm::mat4(1.0f), angle*2, glm::vec3(0.0f, 1.0f, 0.0f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.8f, 0.8f, 1.0f)); //frog
	frogTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(-7.6f, 0.0f, -4.5f)) * glm::rotate(glm::mat4(1.0f), angle*3, glm::vec3(0.0f, 0.0f, 1.0f)); //frogeye1
	frogTransform[2] = glm::translate(glm::mat4(1.0f), glm::vec3(-5.0f, 0.0f, -4.5f)) * glm::rotate(glm::mat4(1.0f), angle*3, glm::vec3(0.0f, 0.0f, 1.0f)); //frogeye2
	frogTransform[3] = glm::translate(glm::mat4(1.0f), glm::vec3(-7.6f, 0.0f, -5.3f)) * glm::rotate(glm::mat4(1.0f), angle*2, glm::vec3(0.0f, 0.0f, 1.0f)); //frogeye11
	frogTransform[4] = glm::translate(glm::mat4(1.0f), glm::vec3(-5.0f, 0.0f, -5.3f)) * glm::rotate(glm::mat4(1.0f), angle*2, glm::vec3(0.0f, 0.0f, 1.0f)); //frogeye21

	pigTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, -0.5f, -7.3f)) * glm::rotate(glm::mat4(1.0f), angle, glm::vec3(0.0f, 1.0f, 0.0f)); //pighead
	pigTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, -3.3f, -7.3f)) * glm::rotate(glm::mat4(1.0f), angle, glm::vec3(0.0f, 1.0f, 0.0f)); //pigbody
	pigTransform[2] = glm::translate(glm::mat4(1.0f), glm::vec3(3.3f, 0.5f, -7.3f)) * glm::rotate(glm::mat4(1.0f), 0.0f, glm::vec3(0.0f, 1.0f, 0.0f)); //pigear1
	pigTransform[3] = glm::translate(glm::mat4(1.0f), glm::vec3(1.3f, 0.5f, -7.3f)) * glm::rotate(glm::mat4(1.0f), 0.0f, glm::vec3(0.0f, 1.0f, 0.0f)); //pigear2
	pigTransform[4] = glm::translate(glm::mat4(1.0f), glm::vec3(3.1f, -0.3f, -8.9f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //pigeye1
	pigTransform[5] = glm::translate(glm::mat4(1.0f), glm::vec3(1.5f, -0.3f, -8.9f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //pigeye2
	pigTransform[6] = glm::translate(glm::mat4(1.0f), glm::vec3(2.3f, -0.8f, -8.8f)) * glm::scale(glm::mat4(1.0f), glm::vec3(1.0f, 1.0f, 0.5f)); //pignose
	pigTransform[7] = glm::translate(glm::mat4(1.0f), glm::vec3(2.6f, -1.0f, -9.0f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //pignose1
	pigTransform[8] = glm::translate(glm::mat4(1.0f), glm::vec3(2.0f, -1.0f, -9.0f)) * glm::scale(glm::mat4(1.0f), glm::vec3(0.5f, 1.0f, 1.0f)); //pignose2

	treeTransform[0] = glm::translate(glm::mat4(1.0f), glm::vec3(0.0f, -3.0f, 0.0f)) * glm::rotate(glm::mat4(1.0f), angle*3, glm::vec3(0.0f, 1.0f, 0.0f)); //tree1
	treeTransform[1] = glm::translate(glm::mat4(1.0f), glm::vec3(0.0f, -5.0f, 0.0f)) * glm::rotate(glm::mat4(1.0f), angle*3, glm::vec3(0.0f, 1.0f, 0.0f)); //tree2
	
	return true;
}

} // moglclass namespace