#pragma once
//////////////////////////////////////////////////////////////////////
// mobile.h: interface for the Mobile class.
// -Kyoung Shin Park (2013 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class BabyMobile
{
public:
	BabyMobile();
	~BabyMobile() { std::cout << "~Mobile" << std::endl; };
	void init();
    void draw(Program* p, glm::mat4 projection, glm::mat4 view, glm::mat4 model);
	bool update(float dt);
	void activate() { active = true; }
	void deactivate() { active = false; }
	bool isActive() { return active; }

protected:
	// Ʋ
	Cylinder frame1; // 5
	Cylinder frame2; // 
	Cylinder frame3; //丷
	Cylinder frame4;
	Cylinder frame5;
	Cylinder frame6;
	Cylinder frame7;
	Cylinder frame8;

	//
	Sphere beehead;
	Sphere beebody;
	Circle beewing1;
	Circle beewing2;
	Circle beewing3;
	Circle beewing4;

	//
	Sphere penguinbody;
	Sphere penguineye;
	Sphere penguineye2;
	Sphere penguinbody2;

	//
	Sphere ladybug;
	Parallelepiped lbleg1;
	Parallelepiped lbleg2;
	Parallelepiped lbleg3;
	Parallelepiped lbleg4;
	Parallelepiped lbleg5;
	Parallelepiped lbleg6;
	Parallelepiped lbleg7;
	Parallelepiped lbleg8;
	Parallelepiped lbleg9;
	Parallelepiped lbleg10;
	Parallelepiped lbleg11;
	Parallelepiped lbleg12;
	Sphere lbspot1;
	Sphere lbspot2;
	Sphere lbspot3;
	Sphere lbspot4;

	//
	Sphere pighead;
	Sphere pigbody;
	Triangle pigear1;
	Triangle pigear2;
	Sphere pigeye1;
	Sphere pigeye2;
	Sphere pignose;
	Sphere pignose1;
	Sphere pignose2;

	//
	Sphere frog;
	Sphere frogeye1;
	Sphere frogeye2;
	Sphere frogeye11;
	Sphere frogeye21;

	//Ʈ
	Cylinder tree1;
	Cylinder tree2;

	glm::vec3 position;
	float direction; // positive/negative direction
	float angle;// wheel angle
	float angle2;
	bool active;

	glm::mat4 bodyTransform;
	glm::mat4 wheelTransform[8];
	glm::mat4 beeTransform[7];
	glm::mat4 penguinTransform[4];
	glm::mat4 ladybugTransform[8];
	glm::mat4 pigTransform[9];
	glm::mat4 frogTransform[6];
	glm::mat4 treeTransform[5];

	static const float MobileDistanceFromHead;
};

} // moglclass namespace